## sirikali 1.2.9

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.6 )
cmake_policy( SET CMP0017 OLD )
cmake_policy( SET CMP0002 OLD )

set_property( GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS ON )

project( sirikali )

set( PGR_VERSION "1.2.9" )

add_definitions( -Wextra -Wall -pedantic )

include_directories( ${PROJECT_BINARY_DIR} )

INCLUDE( GNUInstallDirs )

# uninstall target
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY )

add_custom_target( uninstall
COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake )

INCLUDE(CMakeDependentOption)
INCLUDE(FindPkgConfig)

add_definitions( -D_DEFAULT_SOURCE -fstack-protector-all --param ssp-buffer-size=4 )
include_directories( ${PROJECT_BINARY_DIR} )

if( LIB_SUFFIX )
	set( CMAKE_INSTALL_LIBDIR "${LIB_SUFFIX}" )
	set( CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${LIB_SUFFIX}" )
endif()

pkg_check_modules( PWQUALITY pwquality )

if( PWQUALITY_FOUND )

	find_file( header_pwquality pwquality.h PATHS ${PWQUALITY_INCLUDE_DIRS} )
	find_library( library_pwquality pwquality )

	if( library_pwquality )
		if( header_pwquality )
			file( WRITE ${PROJECT_BINARY_DIR}/can_build_pwquality.h "#define BUILD_PWQUALITY 1\n" )
			file( APPEND ${PROJECT_BINARY_DIR}/can_build_pwquality.h "extern \"C\"\n{\n#include <${header_pwquality}>\n}" )
		else()
			file( WRITE ${PROJECT_BINARY_DIR}/can_build_pwquality.h "#define BUILD_PWQUALITY 0\n" )
		endif()
	else( library_pwquality )
		file( WRITE ${PROJECT_BINARY_DIR}/can_build_pwquality.h "#define BUILD_PWQUALITY 0\n" )
	endif()
else()
	file( WRITE ${PROJECT_BINARY_DIR}/can_build_pwquality.h "#define BUILD_PWQUALITY 0\n" )
endif()

file( WRITE ${PROJECT_BINARY_DIR}/locale_path.h "\n#define TRANSLATION_PATH \"${CMAKE_INSTALL_FULL_DATADIR}/sirikali/translations/\"\n")

file( WRITE  ${PROJECT_BINARY_DIR}/install_prefix.h "\n#define INSTALL_PREFIX \"${CMAKE_INSTALL_PREFIX}/\"\n" )

file( WRITE ${PROJECT_BINARY_DIR}/version.h "
#ifndef THIS_VERSION
#define THIS_VERSION \"${PGR_VERSION}\"
#endif
\n
#ifndef SIRIKALI_VERSION
#define SIRIKALI_VERSION
#define VERSION_STRING \"Version  : ${PGR_VERSION}\\nCopyright: 2016-2017 Francis Banyikwa,mhogomchungu@gmail.com\\nLicense  : GPLv2+\"
#endif
\n" )

if( NOT DEFINED INTERNAL_LXQT_WALLET )
	set( INTERNAL_LXQT_WALLET "false" )
endif()

if( NOT DEFINED QT5 )
	set( QT5 "true" )
endif()

if( APPLE )
	set( QT5 "true" )
endif()

find_file( JSON_HEADER_PATH "nlohmann/json.hpp" )

if( NOT JSON_HEADER_PATH )
	set( JSON_HEADER_PATH "${PROJECT_SOURCE_DIR}/src/3rdParty/json/nlohmann/json.hpp" )
endif()

file( WRITE ${PROJECT_BINARY_DIR}/json.h "\n#include \"${JSON_HEADER_PATH}\"" )
MESSAGE( STATUS "found json.hpp header file at: ${JSON_HEADER_PATH}" )

find_file( GCRYPT_INCLUDE_FILE gcrypt.h )
find_path( GCRYPT_INCLUDE_PATH gcrypt.h )

add_definitions( -I${GCRYPT_INCLUDE_PATH} )

find_library( GCRYPT_LIBRARY gcrypt )

if( NOT GCRYPT_INCLUDE_FILE )
	MESSAGE( FATAL_ERROR "could not find gcrypt header file" )
else()
	MESSAGE( STATUS "found gcrypt header file at: ${GCRYPT_INCLUDE_FILE}" )
endif()

if( NOT GCRYPT_LIBRARY )
	MESSAGE( FATAL_ERROR "could not find gcrypt library" )
else()
	get_filename_component( GCRYPT_LIBRARY_PATH ${GCRYPT_LIBRARY} DIRECTORY )

	MESSAGE( STATUS "found gcrypt library at: ${GCRYPT_LIBRARY}" )
	MESSAGE( STATUS "adding library search path of: ${GCRYPT_LIBRARY_PATH}" )

endif()


if( INTERNAL_LXQT_WALLET )

	message( STATUS "---------------------------------------------------------------------------" )
	message( STATUS "lxqt wallet support will be provided by an internal library" )
	message( STATUS "---------------------------------------------------------------------------" )

	ADD_SUBDIRECTORY( src/3rdParty/lxqt_wallet )
	include_directories( ${PROJECT_SOURCE_DIR}/src/3rdParty/lxqt_wallet/frontend )
	include_directories( ${PROJECT_BINARY_DIR}/src/3rdParty/lxqt_wallet/frontend )
else()
	pkg_check_modules( LXQT_WALLET lxqt-wallet )

	if( NOT LXQT_WALLET_FOUND )

		message( STATUS "ERROR: could not find lxqt_wallet package" )
		message( STATUS "---------------------------------------------------------------------------" )
		message( STATUS "lxqt wallet support will be provided by an internal library" )
		message( STATUS "---------------------------------------------------------------------------" )

		ADD_SUBDIRECTORY( src/3rdParty/lxqt_wallet )
		include_directories( ${PROJECT_SOURCE_DIR}/src/3rdParty/lxqt_wallet/frontend )
		include_directories( ${PROJECT_BINARY_DIR}/src/3rdParty/lxqt_wallet/frontend )
	else()
		if( LXQT_WALLET_VERSION VERSION_GREATER "3.0.0" AND QT5 )

			include_directories( ${LXQT_WALLET_INCLUDEDIR} )
			link_directories( ${LXQT_WALLET_LIBDIR} )

			message( STATUS "---------------------------------------------------------------------------" )
			message( STATUS "lxqt wallet support will be provided by an external library" )
			message( STATUS "---------------------------------------------------------------------------" )
		else()
			message( STATUS "---------------------------------------------------------------------------" )
			message( STATUS "lxqt wallet support will be provided by an internal library" )
			message( STATUS "because external library is too old(<= 2.0.0) or cant build " )
			message( STATUS "with external lxqt_wallet while building with Qt4" )
			message( STATUS "---------------------------------------------------------------------------" )

			ADD_SUBDIRECTORY( src/3rdParty/lxqt_wallet )
			include_directories( ${PROJECT_SOURCE_DIR}/src/3rdParty/lxqt_wallet/frontend )
			include_directories( ${PROJECT_BINARY_DIR}/src/3rdParty/lxqt_wallet/frontend )
		endif()
	endif()
endif()

add_definitions( -std=c++11 )

set( UI_FILES 	src/sirikali.ui
		src/keydialog.ui
		src/dialogmsg.ui
		src/plugin.ui
		src/favorites.ui
		src/readonlywarning.ui
		src/walletconfig.ui
		src/walletconfiginput.ui
		src/options.ui
		src/dialogok.ui
		src/filemanager.ui
		src/securefscreateoptions.ui
		src/cryfscreateoptions.ui
)

set( MOC_FILES 	src/dialogok.h
		src/sirikali.h
		src/keydialog.h
		src/oneinstance.h
		src/dialogmsg.h
		src/plugin.h
		src/favorites.h
		src/readonlywarning.h
		src/walletconfig.h
		src/walletconfiginput.h
		src/options.h
		src/networkAccessManager.hpp
		src/filemanager.h
		src/mountinfo.h
		src/securefscreateoptions.h
		src/cryfscreateoptions.h
		src/3rdParty/tasks/task.h
 )

set( SRC 	src/dialogok.cpp
		src/main.cpp
		src/sirikali.cpp
		src/keydialog.cpp
		src/siritask.cpp
		src/oneinstance.cpp
		src/mountinfo.cpp
		src/utility.cpp
		src/dialogmsg.cpp
		src/favorites.cpp
		src/checkforupdates.cpp
		src/plugin.cpp
		src/tablewidget.cpp
		src/readonlywarning.cpp
		src/walletconfig.cpp
		src/walletconfiginput.cpp
		src/options.cpp
		src/secrets.cpp
		src/filemanager.cpp
		src/securefscreateoptions.cpp
		src/cryfscreateoptions.cpp
		src/utility2.cpp
)

if( APPLE )

	SET( MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/src/MacOSXBundleInfo.plist.in" )
	SET( MACOSX_BUNDLE_BUNDLE_NAME "SiriKali" )
	SET( MACOSX_BUNDLE_COPYRIGHT "(c)2016-2017,Francis Banyikwa,mhogomchungu@gmail.com" )
	SET( MACOSX_BUNDLE_BUNDLE_VERSION "${PGR_VERSION}" )
	SET( MACOSX_BUNDLE_GUI_IDENTIFIER "com.crypto.SiriKali" )
	SET( MACOSX_BUNDLE_SHORT_VERSION_STRING "${PGR_VERSION}" )
	SET( MACOSX_BUNDLE_LONG_VERSION_STRING "${PGR_VERSION}" )
	SET( MACOSX_BUNDLE_ICON_FILE sirikali.icns )
	SET_SOURCE_FILES_PROPERTIES( icons/256x256/sirikali.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
	SET_SOURCE_FILES_PROPERTIES( translations/en_US.qm PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
	SET_SOURCE_FILES_PROPERTIES( translations/fr_FR.qm PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
endif()

if( QT5 )
	find_package( Qt5Widgets REQUIRED )
	find_package( Qt5Core REQUIRED )
	find_package( Qt5Network REQUIRED )

	set( CMAKE_INCLUDE_CURRENT_DIR ON )
	include_directories( ${Qt5Widgets_INCLUDE_DIRS} )
	include_directories( ${Qt5Network_INCLUDE_DIRS} )

	add_definitions( ${Qt5Widgets_DEFINITIONS} )

	QT5_WRAP_UI( UI ${UI_FILES} )
	QT5_WRAP_CPP( MOC ${MOC_FILES} )
	QT5_ADD_RESOURCES( TRAY_RC_SRCS src/icon.qrc )

	INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )
	INCLUDE_DIRECTORIES( ${GCRYPT_INCLUDE_PATH} )

	if( APPLE )
		add_executable( sirikali MACOSX_BUNDLE ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} ${PROJECT_SOURCE_DIR}/icons/256x256/sirikali.icns )
	else()
		add_executable( sirikali ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} )
	endif()

	link_directories( ${GCRYPT_LIBRARY_PATH} )

	TARGET_LINK_LIBRARIES( sirikali ${Qt5Widgets_LIBRARIES} ${Qt5Core_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES} ${library_pwquality} ${GCRYPT_LIBRARY} lxqt-wallet -L${GCRYPT_LIBRARY_PATH})

	message( STATUS "---------------------------------------------------------------------------" )
	message( STATUS "Building GUI components using Qt5" )
	message( STATUS "---------------------------------------------------------------------------\n\n" )
else()
	find_package( Qt4 REQUIRED )

	add_definitions( -I${Qt4_INCLUDE_DIR} )
	add_definitions( -I${QT_HEADERS_DIR} )

	INCLUDE( ${QT_USE_FILE} )
	INCLUDE( ${QT_USE_FILE} )

	INCLUDE( ${QT_USE_FILE} )

	QT4_WRAP_UI( UI ${UI_FILES} )
	QT4_WRAP_CPP( MOC ${MOC_FILES} )
	QT4_ADD_RESOURCES( TRAY_RC_SRCS src/icon.qrc )

	INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )
	INCLUDE_DIRECTORIES( ${GCRYPT_INCLUDE_PATH} )

	link_directories( ${GCRYPT_LIBRARY_PATH} )

	if( APPLE )
		add_executable( sirikali MACOSX_BUNDLE ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} ${PROJECT_SOURCE_DIR}/icons/256x256/sirikali.icns )
	else()
		add_executable( sirikali ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} )
	endif()

	TARGET_LINK_LIBRARIES( sirikali -lQtCore -lQtGui -lQtNetwork ${library_pwquality} ${GCRYPT_LIBRARY} lxqt-wallet -L${GCRYPT_LIBRARY_PATH} )

	message( STATUS "---------------------------------------------------------------------------" )
	message( STATUS "Building GUI components using Qt4" )
	message( STATUS "---------------------------------------------------------------------------\n\n" )
endif()

set_target_properties( sirikali PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -fPIC -pedantic" )

file( WRITE ${PROJECT_BINARY_DIR}/siriPolkit.h "\n#define siriPolkitPath \"${CMAKE_INSTALL_PREFIX}/bin/sirikali.pkexec\"" )

if( APPLE )

SET( plugin_dest_dir sirikali.app/Contents/MacOS )
SET( qtconf_dest_dir sirikali.app/Contents/Resources )
SET( APPS "\${CMAKE_INSTALL_PREFIX}/sirikali.app" )

set_target_properties( sirikali PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/src/MacOSXBundleInfo.plist.in" )

install( TARGETS sirikali BUNDLE DESTINATION . COMPONENT Runtime RUNTIME DESTINATION bin COMPONENT Runtime )

file( COPY icons/256x256/sirikali.icns DESTINATION "sirikali.app/Contents/Resources/" )
file( COPY translations/fr_FR.qm DESTINATION "sirikali.app/Contents/Resources/" )
file( COPY translations/en_US.qm DESTINATION "sirikali.app/Contents/Resources/" )
file( COPY changelog DESTINATION "sirikali.app/Contents/Resources/" )

#install( DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION ${plugin_dest_dir}/plugins COMPONENT Runtime )

#install( CODE " file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${qtconf_dest_dir}/qt.conf\" \"\")" COMPONENT Runtime )

#SET( DIRS ${QT_LIBRARY_DIRS} )

#INSTALL(CODE "
#    file(GLOB_RECURSE QTPLUGINS
#      \"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
#    include(BundleUtilities)
#   fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
#    " COMPONENT Runtime)

#set( CPACK_BINARY_DRAGNDROP ON )
#include( CPack )

else()

install( TARGETS sirikali RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )

install( FILES icons/256x256/sirikali.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps/ )
install( FILES icons/48x48/sirikali.png DESTINATION   ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps/ )

=== src/siripolkit/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

add_definitions( -D_FILE_OFFSET_BITS=64 -Wextra -Wall -pedantic -std=c++11 -I${PROJECT_BINARY_DIR}/siripoltik/ )
include_directories( ${PROJECT_BINARY_DIR}/siripoltik/ )

set( sirikali.pkexecMOC_FILES
	zulupolkit.h
	../3rdParty/tasks/task.h
 )

set( sirikali.pkexecSRC
	main.cpp
	zulupolkit.cpp
)

if( QT5 )
	find_package( Qt5Core REQUIRED )
	find_package( Qt5Network REQUIRED )

	Qt5_WRAP_CPP( sirikali.pkexecMOC ${sirikali.pkexecMOC_FILES} )
else()
	find_package( Qt4 REQUIRED QtCore QtNetwork )

	add_definitions( -I${Qt4_INCLUDE_DIR} )
	add_definitions( -I${QT_HEADERS_DIR} )

	INCLUDE( ${QT_USE_FILE} )
	Qt4_WRAP_CPP( sirikali.pkexecMOC ${sirikali.pkexecMOC_FILES} )
endif()

INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )

add_executable( sirikali.pkexec ${sirikali.pkexecMOC} ${sirikali.pkexecSRC} )

#set_target_properties( sirikali.pkexec PROPERTIES INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}" )

set_target_properties( sirikali.pkexec PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64 -Wextra -Wall -s -fPIC -pedantic" )

if( QT5 )
	target_link_libraries( sirikali.pkexec ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES} )
else()
	target_link_libraries( sirikali.pkexec ${QT_LIBRARIES} ${QT_NETWORK} )
endif()

install( TARGETS sirikali.pkexec RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )

=== src/3rdParty/lxqt_wallet/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.6 )
cmake_policy( SET CMP0017 OLD )

find_package( PkgConfig )

add_subdirectory( backend )
add_subdirectory( frontend )

=== src/3rdParty/lxqt_wallet/frontend/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.6)
cmake_policy(SET CMP0017 OLD)

INCLUDE(FindPkgConfig)

#
# set below variable to "false" if you want to build a static library
#
set(BUILD_SHARED "false")

set(LIBRARY_VERSION "2.0.0")

add_definitions(-I${PROJECT_BINARY_DIR}/frontend)
add_definitions(-I${PROJECT_BINARY_DIR}/backend)
add_definitions(-I${PROJECT_BINARY_DIR}/src/lxqt_wallet/frontend)
add_definitions(-I${PROJECT_BINARY_DIR}/src/lxqt_wallet/backend)
add_definitions(-I${PROJECT_BINARY_DIR})

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

if( APPLE )
	file( WRITE ${PROJECT_BINARY_DIR}/osx_keychain.h "#define OSX_KEYCHAIN 1" )
else()
	file( WRITE ${PROJECT_BINARY_DIR}/osx_keychain.h "#define OSX_KEYCHAIN 0" )
endif()

if(QT5)
	find_package(Qt5Widgets REQUIRED)
	find_package(Qt5Core REQUIRED)

	set(CMAKE_INCLUDE_CURRENT_DIR ON)
	include_directories(${Qt5Widgets_INCLUDE_DIRS})

	add_definitions(${Qt5Widgets_DEFINITIONS})

	set( KF5 "true" )
else()
	find_package(Qt4 REQUIRED)

	SET(QT_USE_QTCORE TRUE)
	SET(QT_USE_QTGUI TRUE)

	add_definitions(-I${Qt4_INCLUDE_DIR})
	add_definitions(-I${QT_HEADERS_DIR})

	INCLUDE(${QT_USE_FILE})

	INCLUDE(${QT_USE_FILE})
endif()

if(NOSECRETSUPPORT)
	SET(SECRET_SUPPORT "false")
	file(WRITE  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_SECRET_SUPPORT 0\n")
else()
	pkg_check_modules(LIBSECRET libsecret-1)

	if(LIBSECRET_FOUND)
		add_subdirectory(libsecret)
		SET(SECRET_SUPPORT "true")
		file(WRITE  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_SECRET_SUPPORT 1\n")
	else()
		SET(SECRET_SUPPORT "false")
		file(WRITE  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_SECRET_SUPPORT 0\n")
	endif()
endif()

add_definitions(-std=c++11)

if(NOKDESUPPORT)
	SET(KDE_SUPPORT "false")
	SET(KWALLET_SUPPORT "false")
	file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 0\n")
else()
	if(KF5)
		find_package(Qt5Widgets REQUIRED)
		find_package(Qt5Core REQUIRED)

		find_package(KF5Wallet QUIET)
		find_package(KF5Notifications QUIET)

		if(KF5Wallet_FOUND AND KF5Notifications_FOUND )
			file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 1\n")
			SET(KDE_SUPPORT "true")
			SET(KWALLET_SUPPORT "true")
		else()
			file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 0\n")
			SET(KDE_SUPPORT "false")
			SET(KWALLET_SUPPORT "false")
		endif()
	else()
		find_package(KDE4 QUIET)
		if(KDE4_FOUND)
			include(KDE4Defaults)
			include_directories(${KDE4_INCLUDES})
			add_definitions(-I${KDE4_INCLUDE_DIR})

			add_definitions(-I${Qt4_INCLUDE_DIR})
			add_definitions(-I${QT_HEADERS_DIR})

			SET(KDE_SUPPORT "true")

			if(NOKWALLETSUPPORT)
				SET(KWALLET_SUPPORT "false")
				file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 0\n")
			else()
				find_library(LIBKWALLETBACKEND libkwalletbackend.so)
				if(NOT LIBKWALLETBACKEND)
					# some distributions do not have libkwalletbackend.so for reasons i currently do not know
					# look for libkwalletbackend.sp.4 when the above happen
					find_library(LIBKWALLETBACKEND libkwalletbackend.so.4)
					if(NOT LIBKWALLETBACKEND)
						file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 0\n")
						SET(KWALLET_SUPPORT "false")
					else()
						SET(KWALLET_SUPPORT "true")
						file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 1\n")
					endif()
				else()
					SET(KWALLET_SUPPORT "true")
					file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 1\n")
				endif()
			endif()

			find_library(LIBKDEUI libkdeui.so)
			if(NOT LIBKDEUI)
				# adding this one just in case the same case as above happen
				find_library(LIBKDEUI libkdeui.so.5)
			endif()

			if(NOT LIBKDEUI)
				SET(KDE_SUPPORT "false")
				message(STATUS "could not find libkdeui.so or libkdeui.so.5,please make sure you have kde development libraries installed and try again")
			endif()

			find_library(LIBKDECORE libkdecore.so)
			if(NOT LIBKDECORE)
				# adding this one just in case the same case as above happen
				find_library(LIBKDECORE libkdecore.so.5)
			endif()

			if(NOT LIBKDECORE)
				SET(KDE_SUPPORT "false")
				message(STATUS "could not find libkdecore.so or libkdecore.so.5,please make sure you have kde development libraries installed and try again")
			endif()
		else()
			file(APPEND  ${PROJECT_BINARY_DIR}/storage_manager.h "\n#define HAS_KWALLET_SUPPORT 0\n")
			SET(KDE_SUPPORT "false")
			SET(KWALLET_SUPPORT "false")
		endif()
	endif()

endif()

if(KWALLET_SUPPORT)
	message(STATUS "\n--------------------------------------------------------------------------")
	message(STATUS "kwallet support found,will build kwallet functionality")
	message(STATUS "-----------------------------------------------------------------------")
else()
	message(STATUS "\n--------------------------------------------------------------------------")
	message(STATUS "kwallet support NOT found,will not build kwallet functionality")
	message(STATUS "-----------------------------------------------------------------------")
endif()

if(SECRET_SUPPORT)
	message(STATUS "\n--------------------------------------------------------------------------")
	message(STATUS "libsecret support found,will build libsecret functionality")
	message(STATUS "-----------------------------------------------------------------------")
else()
	message(STATUS "\n--------------------------------------------------------------------------")
	message(STATUS "libsecret support NOT found,will not build libsecret functionality")
	message(STATUS "-----------------------------------------------------------------------")
endif()

set(UI_FILES 	changepassworddialog.ui password_dialog.ui)

set(MOC_FILES 	changepassworddialog.h password_dialog.h task.h)
set(MOC_FILES_1 changepassworddialog.h password_dialog.h lxqt_kwallet.h task.h)
set(MOC_FILES_2 changepassworddialog.h password_dialog.h lxqt_kwallet.h task.h)
set(MOC_FILES_3 changepassworddialog.h password_dialog.h task.h)

set(SRC 	lxqt_osx_keychain.cpp changepassworddialog.cpp password_dialog.cpp lxqt_internal_wallet.cpp lxqt_wallet.cpp)
set(SRC_1 	lxqt_osx_keychain.cpp changepassworddialog.cpp password_dialog.cpp lxqt_internal_wallet.cpp lxqt_wallet.cpp lxqt_kwallet.cpp)
set(SRC_2 	lxqt_osx_keychain.cpp changepassworddialog.cpp password_dialog.cpp lxqt_internal_wallet.cpp lxqt_wallet.cpp lxqt_kwallet.cpp lxqt_libsecret.cpp)
set(SRC_3 	lxqt_osx_keychain.cpp changepassworddialog.cpp password_dialog.cpp lxqt_internal_wallet.cpp lxqt_wallet.cpp lxqt_libsecret.cpp)

if(BUILD_SHARED)
	set( LIBRARY_TYPE "SHARED")
else()
	set( LIBRARY_TYPE "STATIC")
endif()

if(QT5)

Qt5_WRAP_UI(UI ${UI_FILES})

if(KDE_SUPPORT)
	if(KWALLET_SUPPORT)
		if(SECRET_SUPPORT)
			Qt5_WRAP_CPP(MOC ${MOC_FILES_2})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_2} ${MOC})
			target_link_libraries(lxqt-wallet secretlib)
			target_link_libraries(lxqt-wallet "${Qt5Widgets_LIBRARIES}")
			target_link_libraries(lxqt-wallet "${Qt5Core_LIBRARIES}")
			target_link_libraries(lxqt-wallet KF5::Wallet KF5::Notifications)
		else()
			Qt5_WRAP_CPP(MOC ${MOC_FILES_1})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_1} ${MOC})
			target_link_libraries(lxqt-wallet "${Qt5Widgets_LIBRARIES}")
			target_link_libraries(lxqt-wallet "${Qt5Core_LIBRARIES}")
			target_link_libraries(lxqt-wallet KF5::Wallet KF5::Notifications)
		endif()
	else()
		if(SECRET_SUPPORT)
			Qt5_WRAP_CPP(MOC ${MOC_FILES_3})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_3} ${MOC})
			target_link_libraries(lxqt-wallet secretlib)
			target_link_libraries(lxqt-wallet "${Qt5Widgets_LIBRARIES}")
			target_link_libraries(lxqt-wallet "${QtCore_LIBRARIES}")
		else()
			Qt5_WRAP_CPP(MOC ${MOC_FILES})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC} ${MOC})
			target_link_libraries(lxqt-wallet "${Qt5Widgets_LIBRARIES}")
			target_link_libraries(lxqt-wallet "${QtCore_LIBRARIES}")
			target_link_libraries(lxqt-wallet "${LIBKDEUI}")
			target_link_libraries(lxqt-wallet "${LIBKDECORE}")
		endif()
	endif()
else()
	if(SECRET_SUPPORT)
		Qt5_WRAP_CPP(MOC ${MOC_FILES_3})
		add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_3} ${MOC})
		target_link_libraries(lxqt-wallet secretlib)
		target_link_libraries(lxqt-wallet "${Qt5Widgets_LIBRARIES}")
		target_link_libraries(lxqt-wallet "${QtCore_LIBRARIES}")
	else()
		Qt5_WRAP_CPP(MOC ${MOC_FILES})
		add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC} ${MOC})
		target_link_libraries(lxqt-wallet "${Qt5Widgets_LIBRARIES}")
		target_link_libraries(lxqt-wallet "${QtCore_LIBRARIES}")
	endif()
endif()

else()

Qt4_WRAP_UI(UI ${UI_FILES})

if(KDE_SUPPORT)
	if(KWALLET_SUPPORT)
		if(SECRET_SUPPORT)
			Qt4_WRAP_CPP(MOC ${MOC_FILES_2})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_2} ${MOC})
			target_link_libraries(lxqt-wallet secretlib)
			set(link_libraries "-L${KDE4_LIB_DIR} -L${QT_LIBRARY_DIR} ${LIBKDEUI} ${LIBKDECORE} ${LIBKWALLETBACKEND}")
		else()
			Qt4_WRAP_CPP(MOC ${MOC_FILES_1})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_1} ${MOC})
			set(link_libraries "-L${KDE4_LIB_DIR} -L${QT_LIBRARY_DIR} ${LIBKDEUI} ${LIBKDECORE} ${LIBKWALLETBACKEND}")
		endif()
	else()
		if(SECRET_SUPPORT)
			Qt4_WRAP_CPP(MOC ${MOC_FILES_3})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_3} ${MOC})
			target_link_libraries(lxqt-wallet secretlib)
			set(link_libraries "-L${KDE4_LIB_DIR} -L${QT_LIBRARY_DIR}")
		else()
			Qt4_WRAP_CPP(MOC ${MOC_FILES})
			add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC} ${MOC})
			set(link_libraries "-L${KDE4_LIB_DIR} -L${QT_LIBRARY_DIR} ${LIBKDEUI} ${LIBKDECORE}")
		endif()

	endif()
else()
	if(SECRET_SUPPORT)
		Qt4_WRAP_CPP(MOC ${MOC_FILES_3})
		add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC_3} ${MOC})
		target_link_libraries(lxqt-wallet secretlib)
		set(link_libraries "-L${KDE4_LIB_DIR} -L${QT_LIBRARY_DIR}")
	else()
		Qt4_WRAP_CPP(MOC ${MOC_FILES})
		add_library(lxqt-wallet ${LIBRARY_TYPE} ${UI} ${SRC} ${MOC})
	endif()
endif()

endif()

set_target_properties(lxqt-wallet PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64 -Wextra -Wall -s -fPIC -pedantic ")
set_target_properties(lxqt-wallet PROPERTIES SOVERSION "${LIBRARY_VERSION}")
TARGET_LINK_LIBRARIES(lxqt-wallet "${link_libraries}" lxqt-wallet-backend)

if( APPLE )
	find_library(COREFOUNDATION_LIBRARY CoreFoundation REQUIRED)
	find_library(SECURITY_LIBRARY Security REQUIRED)
	TARGET_LINK_LIBRARIES(lxqt-wallet ${COREFOUNDATION_LIBRARY} ${SECURITY_LIBRARY})
endif()

if(BUILD_SHARED)
	install(TARGETS lxqt-wallet RUNTIME LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

	install(FILES lxqt_wallet.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/lxqt")

	file( WRITE ${PROJECT_BINARY_DIR}/lxqt-wallet.pc
"prefix=${CMAKE_INSTALL_PREFIX}
exec_prefix=${CMAKE_INSTALL_PREFIX}
libdir=${CMAKE_INSTALL_FULL_LIBDIR}
includedir=${CMAKE_INSTALL_FULL_INCLUDEDIR}/lxqt

Name: lxqt_wallet
Description: lxqt secure storage system
Version: ${LIBRARY_VERSION}
Libs: -L${CMAKE_INSTALL_FULL_LIBDIR} -lQtGui -lQtCore -lgcrypt
Cflags: -I${CMAKE_INSTALL_FULL_INCLUDEDIR}/lxqt
\n")

	install(FILES ${PROJECT_BINARY_DIR}/lxqt-wallet.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/ PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ )
endif()

=== debian/changelog ===
sirikali (1.2.9-1) unstable; urgency=medium

  * New upstream version.

 -- David Steele <steele@debian.org>  Tue, 11 Jul 2017 07:25:01 -0400

=== debian/control ===
Source: sirikali
Section: admin
Priority: extra
Maintainer: David Steele <steele@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               pkg-config,
               libgcrypt20-dev,
               libsecret-1-dev,
               qtbase5-dev,
               chrpath,
               bzip2,
               pandoc,
Standards-Version: 4.0.0
Homepage: http://mhogomchungu.github.io/sirikali
Vcs-Git: https://github.com/davesteele/sirikali.git -b debian
Vcs-Browser: https://github.com/davesteele/sirikali

Package: sirikali
Architecture: amd64 armel arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x alpha hppa kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe ppc64 sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}, cryfs [!armel]
Recommends: encfs [armel]
Suggests: encfs [!armel]
Description: Manage user encrypted volumes
 Sirikali provides a Qt/C++ GUI front end to cryfs,gocryptfs,securefs and encfs,
 allowing the user to create, mount, and unmount encrypted volumes.

## sirikali 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,16 @@
-cmake_minimum_required( VERSION 2.6 )
-cmake_policy( SET CMP0017 OLD )
-cmake_policy( SET CMP0002 OLD )
+cmake_minimum_required( VERSION 3.0 )
 
 set_property( GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS ON )
 
 project( sirikali )
 
-set( PGR_VERSION "1.2.9" )
+set( PGR_VERSION "1.3.1" )
 
 add_definitions( -Wextra -Wall -pedantic )
+
+set( CMAKE_CXX_STANDARD 14 )
+set( CMAKE_CXX_STANDARD_REQUIRED ON )
+set( CMAKE_CXX_EXTENSIONS OFF)
 
 include_directories( ${PROJECT_BINARY_DIR} )
 
@@ -160,7 +162,7 @@
 	endif()
 endif()
 
-add_definitions( -std=c++11 )
+add_definitions( -std=c++14 )
 
 set( UI_FILES 	src/sirikali.ui
 		src/keydialog.ui
@@ -188,12 +190,12 @@
 		src/walletconfig.h
 		src/walletconfiginput.h
 		src/options.h
-		src/networkAccessManager.hpp
 		src/filemanager.h
 		src/mountinfo.h
 		src/securefscreateoptions.h
 		src/cryfscreateoptions.h
 		src/3rdParty/tasks/task.h
+		src/3rdParty/NetworkAccessManager/networkAccessManager.hpp
  )
 
 set( SRC 	src/dialogok.cpp

=== src/3rdParty/lxqt_wallet/backend/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

INCLUDE(FindPkgConfig)

find_file( GCRYPT_INCLUDE_FILE gcrypt.h )
find_path( GCRYPT_INCLUDE_PATH gcrypt.h )

find_library( GCRYPT_LIBRARY gcrypt )

if( NOT GCRYPT_INCLUDE_FILE )
	MESSAGE( FATAL_ERROR "could not find gcrypt header file" )
else()
	MESSAGE( STATUS "found gcrypt header file: ${GCRYPT_INCLUDE_FILE}" )
endif()

if( NOT GCRYPT_LIBRARY )
	MESSAGE( FATAL_ERROR "could not find gcrypt library(libgcrypt.so)" )
else()
	MESSAGE( STATUS "found gcrypt library: ${GCRYPT_LIBRARY}" )
endif()

get_filename_component( GCRYPT_LIBRARY_PATH ${GCRYPT_LIBRARY} DIRECTORY )

add_library( lxqt-wallet-backend STATIC lxqtwallet.c )
set_target_properties( lxqt-wallet-backend PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64 -Wall -s -fPIC -pedantic -I${GCRYPT_INCLUDE_PATH}" )
set_target_properties( lxqt-wallet-backend PROPERTIES LINK_FLAGS "-pie" )
TARGET_LINK_LIBRARIES( lxqt-wallet-backend "${GCRYPT_LIBRARY}" )
link_directories( "${GCRYPT_LIBRARY_PATH}" )

=== src/3rdParty/lxqt_wallet/frontend/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
 
 cmake_minimum_required(VERSION 2.6)
-cmake_policy(SET CMP0017 OLD)
 
 INCLUDE(FindPkgConfig)

=== debian/changelog ===
sirikali (1.3.1-1) unstable; urgency=medium

  *  New upstream version.

 -- David Steele <steele@debian.org>  Fri, 20 Oct 2017 23:49:20 -0400

sirikali (1.3.0-1) unstable; urgency=medium

  * New upstream version. 
  * Save the source signature in an archivable format.
  * Kill existing sirikali daemon on upgrade.

 -- David Steele <steele@debian.org>  Tue, 12 Sep 2017 23:09:37 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: sirikali
 Section: admin
-Priority: extra
+Priority: optional
 Maintainer: David Steele <steele@debian.org>
 Build-Depends: debhelper (>= 9),
                cmake,
@@ -11,13 +11,13 @@
                chrpath,
                bzip2,
                pandoc,
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: http://mhogomchungu.github.io/sirikali
 Vcs-Git: https://github.com/davesteele/sirikali.git -b debian
 Vcs-Browser: https://github.com/davesteele/sirikali
 
 Package: sirikali
-Architecture: amd64 armel arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x alpha hppa kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe ppc64 sparc64 x32
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, cryfs [!armel]
 Recommends: encfs [armel]
 Suggests: encfs [!armel]

=== debian/rules ===
#!/usr/bin/make -f

PKD = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG = $(shell dpkg-parsechangelog -l$(PKD)/changelog --show-field=Source)
VER ?= $(shell (dpkg-parsechangelog -l$(PKD)/changelog | grep Version | sed 's/Version..//' | sed 's/-.\+//'))

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=RELEASE -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) -DQT5=true  -DNOSECRETSUPPORT=false -DNOKDESUPPORT=true

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build
	pandoc debian/sirikali.1.md -s -t man -o debian/sirikali.1

get-orig-source:  $(info I: $(PKG)_$(VER))
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)


.PHONY: override_dh_auto_configure get-orig-source

## sirikali 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 project( sirikali )
 
-set( PGR_VERSION "1.3.1" )
+set( PGR_VERSION "1.3.2" )
 
 add_definitions( -Wextra -Wall -pedantic )
 
@@ -28,7 +28,12 @@
 INCLUDE(CMakeDependentOption)
 INCLUDE(FindPkgConfig)
 
-add_definitions( -D_DEFAULT_SOURCE -fstack-protector-all --param ssp-buffer-size=4 )
+if( WIN32 )
+    add_definitions( -D_DEFAULT_SOURCE )
+else()
+    add_definitions( -D_DEFAULT_SOURCE -fstack-protector-all --param ssp-buffer-size=4 )
+endif()
+
 include_directories( ${PROJECT_BINARY_DIR} )
 
 if( LIB_SUFFIX )
@@ -68,7 +73,7 @@
 \n
 #ifndef SIRIKALI_VERSION
 #define SIRIKALI_VERSION
-#define VERSION_STRING \"Version  : ${PGR_VERSION}\\nCopyright: 2016-2017 Francis Banyikwa,mhogomchungu@gmail.com\\nLicense  : GPLv2+\"
+#define VERSION_STRING \"Version  : ${PGR_VERSION}\\nCopyright: 2016-2018 Francis Banyikwa,mhogomchungu@gmail.com\\nLicense  : GPLv2+\"
 #endif
 \n" )
 
@@ -76,13 +81,11 @@
 	set( INTERNAL_LXQT_WALLET "false" )
 endif()
 
-if( NOT DEFINED QT5 )
-	set( QT5 "true" )
-endif()
-
-if( APPLE )
-	set( QT5 "true" )
-endif()
+if( DEFINED QT5 AND NOT QT5 )
+	message( FATAL_ERROR "Qt4 Build is no longer supported" )
+endif()
+
+set( QT5 "true" )
 
 find_file( JSON_HEADER_PATH "nlohmann/json.hpp" )
 
@@ -116,6 +119,10 @@
 
 endif()
 
+ADD_SUBDIRECTORY( src/3rdParty/tasks )
+ADD_SUBDIRECTORY( src/3rdParty/NetworkAccessManager )
+include_directories( src/3rdParty/tasks )
+include_directories( src/3rdParty/NetworkAccessManager )
 
 if( INTERNAL_LXQT_WALLET )
 
@@ -174,18 +181,28 @@
 		src/walletconfiginput.ui
 		src/options.ui
 		src/dialogok.ui
+		src/help.ui
+		src/gocryptfscreateoptions.ui
 		src/filemanager.ui
 		src/securefscreateoptions.ui
 		src/cryfscreateoptions.ui
+                src/configfileoption.ui
+                src/configoptions.ui
 )
 
-set( MOC_FILES 	src/dialogok.h
+set( MOC_FILES
+                src/configoptions.h
+                src/configfileoption.h
+                src/checkforupdates.h
+                src/dialogok.h
+                src/help.h
 		src/sirikali.h
 		src/keydialog.h
 		src/oneinstance.h
 		src/dialogmsg.h
 		src/plugin.h
 		src/favorites.h
+		src/gocryptfscreateoptions.h
 		src/readonlywarning.h
 		src/walletconfig.h
 		src/walletconfiginput.h
@@ -194,15 +211,17 @@
 		src/mountinfo.h
 		src/securefscreateoptions.h
 		src/cryfscreateoptions.h
-		src/3rdParty/tasks/task.h
-		src/3rdParty/NetworkAccessManager/networkAccessManager.hpp
  )
 
 set( SRC 	src/dialogok.cpp
 		src/main.cpp
+		src/gocryptfscreateoptions.cpp
+		src/configoptions.cpp
+                src/configfileoption.cpp
 		src/sirikali.cpp
 		src/keydialog.cpp
 		src/siritask.cpp
+		src/help.cpp
 		src/oneinstance.cpp
 		src/mountinfo.cpp
 		src/utility.cpp
@@ -226,7 +245,7 @@
 
 	SET( MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/src/MacOSXBundleInfo.plist.in" )
 	SET( MACOSX_BUNDLE_BUNDLE_NAME "SiriKali" )
-	SET( MACOSX_BUNDLE_COPYRIGHT "(c)2016-2017,Francis Banyikwa,mhogomchungu@gmail.com" )
+	SET( MACOSX_BUNDLE_COPYRIGHT "(c)2016-2018,Francis Banyikwa,mhogomchungu@gmail.com" )
 	SET( MACOSX_BUNDLE_BUNDLE_VERSION "${PGR_VERSION}" )
 	SET( MACOSX_BUNDLE_GUI_IDENTIFIER "com.crypto.SiriKali" )
 	SET( MACOSX_BUNDLE_SHORT_VERSION_STRING "${PGR_VERSION}" )
@@ -237,71 +256,46 @@
 	SET_SOURCE_FILES_PROPERTIES( translations/fr_FR.qm PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
 endif()
 
-if( QT5 )
-	find_package( Qt5Widgets REQUIRED )
-	find_package( Qt5Core REQUIRED )
-	find_package( Qt5Network REQUIRED )
-
-	set( CMAKE_INCLUDE_CURRENT_DIR ON )
-	include_directories( ${Qt5Widgets_INCLUDE_DIRS} )
-	include_directories( ${Qt5Network_INCLUDE_DIRS} )
-
-	add_definitions( ${Qt5Widgets_DEFINITIONS} )
-
-	QT5_WRAP_UI( UI ${UI_FILES} )
-	QT5_WRAP_CPP( MOC ${MOC_FILES} )
-	QT5_ADD_RESOURCES( TRAY_RC_SRCS src/icon.qrc )
-
-	INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )
-	INCLUDE_DIRECTORIES( ${GCRYPT_INCLUDE_PATH} )
-
-	if( APPLE )
-		add_executable( sirikali MACOSX_BUNDLE ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} ${PROJECT_SOURCE_DIR}/icons/256x256/sirikali.icns )
+find_package( Qt5Widgets REQUIRED )
+find_package( Qt5Core REQUIRED )
+find_package( Qt5Network REQUIRED )
+
+set( CMAKE_INCLUDE_CURRENT_DIR ON )
+include_directories( ${Qt5Widgets_INCLUDE_DIRS} )
+include_directories( ${Qt5Network_INCLUDE_DIRS} )
+
+add_definitions( ${Qt5Widgets_DEFINITIONS} )
+
+QT5_WRAP_UI( UI ${UI_FILES} )
+QT5_WRAP_CPP( MOC ${MOC_FILES} )
+QT5_ADD_RESOURCES( TRAY_RC_SRCS src/icon.qrc )
+
+INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )
+INCLUDE_DIRECTORIES( ${GCRYPT_INCLUDE_PATH} )
+
+if( APPLE )
+	add_executable( sirikali MACOSX_BUNDLE ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} ${PROJECT_SOURCE_DIR}/icons/256x256/sirikali.icns )
+else()
+        if( WIN32)
+                add_executable( sirikali WIN32 ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} )
 	else()
-		add_executable( sirikali ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} )
+                add_executable( sirikali ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} )
 	endif()
-
-	link_directories( ${GCRYPT_LIBRARY_PATH} )
-
-	TARGET_LINK_LIBRARIES( sirikali ${Qt5Widgets_LIBRARIES} ${Qt5Core_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES} ${library_pwquality} ${GCRYPT_LIBRARY} lxqt-wallet -L${GCRYPT_LIBRARY_PATH})
-
-	message( STATUS "---------------------------------------------------------------------------" )
-	message( STATUS "Building GUI components using Qt5" )
-	message( STATUS "---------------------------------------------------------------------------\n\n" )
-else()
-	find_package( Qt4 REQUIRED )
-
-	add_definitions( -I${Qt4_INCLUDE_DIR} )
-	add_definitions( -I${QT_HEADERS_DIR} )
-
-	INCLUDE( ${QT_USE_FILE} )
-	INCLUDE( ${QT_USE_FILE} )
-
-	INCLUDE( ${QT_USE_FILE} )
-
-	QT4_WRAP_UI( UI ${UI_FILES} )
-	QT4_WRAP_CPP( MOC ${MOC_FILES} )
-	QT4_ADD_RESOURCES( TRAY_RC_SRCS src/icon.qrc )
-
-	INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )
-	INCLUDE_DIRECTORIES( ${GCRYPT_INCLUDE_PATH} )
-
-	link_directories( ${GCRYPT_LIBRARY_PATH} )
-
-	if( APPLE )
-		add_executable( sirikali MACOSX_BUNDLE ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} ${PROJECT_SOURCE_DIR}/icons/256x256/sirikali.icns )
-	else()
-		add_executable( sirikali ${MOC} ${UI} ${SRC} ${TRAY_RC_SRCS} )
-	endif()
-
-	TARGET_LINK_LIBRARIES( sirikali -lQtCore -lQtGui -lQtNetwork ${library_pwquality} ${GCRYPT_LIBRARY} lxqt-wallet -L${GCRYPT_LIBRARY_PATH} )
-
-	message( STATUS "---------------------------------------------------------------------------" )
-	message( STATUS "Building GUI components using Qt4" )
-	message( STATUS "---------------------------------------------------------------------------\n\n" )
-endif()
-
-set_target_properties( sirikali PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -fPIC -pedantic" )
+endif()
+
+link_directories( ${GCRYPT_LIBRARY_PATH} )
+
+TARGET_LINK_LIBRARIES( sirikali ${Qt5Widgets_LIBRARIES} ${Qt5Core_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES} ${library_pwquality} ${GCRYPT_LIBRARY} lxqt-wallet tasks networkAccessManager -L${GCRYPT_LIBRARY_PATH})
+
+message( STATUS "---------------------------------------------------------------------------" )
+message( STATUS "Building GUI components using Qt5" )
+message( STATUS "---------------------------------------------------------------------------\n\n" )
+
+if( WIN32 )
+    set_target_properties( sirikali PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -pedantic" )
+else()
+    set_target_properties( sirikali PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -fPIC -pedantic" )
+endif()
 
 file( WRITE ${PROJECT_BINARY_DIR}/siriPolkit.h "\n#define siriPolkitPath \"${CMAKE_INSTALL_PREFIX}/bin/sirikali.pkexec\"" )
 
@@ -318,6 +312,9 @@
 file( COPY icons/256x256/sirikali.icns DESTINATION "sirikali.app/Contents/Resources/" )
 file( COPY translations/fr_FR.qm DESTINATION "sirikali.app/Contents/Resources/" )
 file( COPY translations/en_US.qm DESTINATION "sirikali.app/Contents/Resources/" )
+file( COPY translations/de_DE.qm DESTINATION "sirikali.app/Contents/Resources/" )
+file( COPY translations/es_MX.qm DESTINATION "sirikali.app/Contents/Resources/" )
+
 file( COPY changelog DESTINATION "sirikali.app/Contents/Resources/" )
 
 #install( DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION ${plugin_dest_dir}/plugins COMPONENT Runtime )

=== src/siripolkit/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,6 @@
 
 set( sirikali.pkexecMOC_FILES
 	zulupolkit.h
-	../3rdParty/tasks/task.h
  )
 
 set( sirikali.pkexecSRC
@@ -37,9 +36,9 @@
 set_target_properties( sirikali.pkexec PROPERTIES COMPILE_FLAGS "-D_FILE_OFFSET_BITS=64 -Wextra -Wall -s -fPIC -pedantic" )
 
 if( QT5 )
-	target_link_libraries( sirikali.pkexec ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES} )
+	target_link_libraries( sirikali.pkexec ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES} tasks )
 else()
-	target_link_libraries( sirikali.pkexec ${QT_LIBRARIES} ${QT_NETWORK} )
+	target_link_libraries( sirikali.pkexec ${QT_LIBRARIES} ${QT_NETWORK} tasks )
 endif()
 
 install( TARGETS sirikali.pkexec RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )

=== src/3rdParty/NetworkAccessManager/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.0 )

project( networkAccessManager )

add_definitions( -Wextra -Wall -pedantic )

set( CMAKE_CXX_STANDARD 11 )
set( CMAKE_CXX_STANDARD_REQUIRED ON )
set( CMAKE_CXX_EXTENSIONS OFF)

INCLUDE(CMakeDependentOption)

find_package( Qt5Core REQUIRED )

QT5_WRAP_CPP( MOC_LIBRARY networkAccessManager.hpp )

include_directories( ${Qt5Core_INCLUDE_DIRS} )

add_library( networkAccessManager STATIC ${MOC_LIBRARY} )

TARGET_LINK_LIBRARIES( networkAccessManager ${Qt5Core_LIBRARIES} )

if( WIN32 )
	set_target_properties( networkAccessManager PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -pedantic " )
else()
	set_target_properties( networkAccessManager PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -fPIC -pedantic " )
endif()

=== src/3rdParty/tasks/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.0 )

project( tasks )

add_definitions( -Wextra -Wall -pedantic )

set( CMAKE_CXX_STANDARD 11 )
set( CMAKE_CXX_STANDARD_REQUIRED ON )
set( CMAKE_CXX_EXTENSIONS OFF)

INCLUDE(CMakeDependentOption)

find_package( Qt5Core REQUIRED )

QT5_WRAP_CPP( MOC task.hpp example.h )
QT5_WRAP_CPP( MOC_LIBRARY task.hpp )

include_directories( ${Qt5Core_INCLUDE_DIRS} )

#add_executable( example example.cpp main.cpp ${MOC} )

add_library( tasks STATIC ${MOC_LIBRARY} )

#TARGET_LINK_LIBRARIES( example ${Qt5Core_LIBRARIES} )

if( WIN32 )
	set_target_properties( tasks PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -pedantic " )
else()
	set_target_properties( tasks PROPERTIES COMPILE_FLAGS "-Wextra -Wall -s -fPIC -pedantic " )
endif()

=== debian/changelog ===
sirikali (1.3.2-1) unstable; urgency=medium

  * New upstream version

 -- David Steele <steele@debian.org>  Tue, 02 Jan 2018 21:06:34 -0500

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                chrpath,
                bzip2,
                pandoc,
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 Homepage: http://mhogomchungu.github.io/sirikali
 Vcs-Git: https://github.com/davesteele/sirikali.git -b debian
 Vcs-Browser: https://github.com/davesteele/sirikali

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,7 @@
 PKD = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
 PKG = $(shell dpkg-parsechangelog -l$(PKD)/changelog --show-field=Source)
 VER ?= $(shell (dpkg-parsechangelog -l$(PKD)/changelog | grep Version | sed 's/Version..//' | sed 's/-.\+//'))
+PRODUCT_VER = $(shell (grep version changelog | tail -1 | awk '{print $2}'))
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -19,6 +20,8 @@
 	dh $@ --parallel
 
 override_dh_auto_build:
+	if [ ${VER} != ${PRODUCT_VER} ] ; then exit 1 ; fi
+	if ! grep -q \"${VER}\" ./debian/sirikali.appdata.xml ; then exit 1 ; fi
 	dh_auto_build
 	pandoc debian/sirikali.1.md -s -t man -o debian/sirikali.1
